/**************************************/
/*    3-D OBJECT DRAWING PROGRAM      */
/*    V. MILLER  JUNE 1997            */
/*    3-D PROJECTION DRAWING PROGRAM  */
/*                                    */
/*                                    */
/*    READS *._3D FILES WHICH ARE     */
/*    ASCII VERSIONS OF BINARY *.3DS  */
/*    FILES                           */
/*                                    */
/*    *.3DS FILES ARE CONVERTED TO    */
/*    ASCII *._3D FILES WITH PROGRAM  */
/*    3DSRDR.C FROM FINLAND (x2ftp)   */
/**************************************/

#include <dos.h>
#include <math.h>
#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
/* #include <graphics.h> */
#include <alloc.h>
#include <mem.h>
#include <bios.h>
#include <process.h>
#include "C:\TURBO_C\VGA_FUNC.H"    /* Include Mode 13h Graphics Routines */

int graphics_adapter,graphics_mode;
int ixpt,iypt,ipen,i,ipl,iv,ivert,j,k,p,istyle,ixtxt,iytxt;
int nvert,nplate,npvert,nfaces,aa,bb,cc,icolor,itemp;
int inumplate,inumvertice,istartplate,index,npoints,npplate;
int face_color[600];
float scicon,pilotx,piloty,pilotz,vertex[3][600],faces[3][600];
float x,y,z,cgx,cgy,cgz;
float xa=0.,ya=0.,za=0.;
float xmax,xmin,ymax,ymin,zmax,zmin,xspread,yspread,zspread,spread;
float xmiddle,ymiddle,zmiddle;
float r1=0.,r2=0.,r3=0.;
float sr1=0., sr2=0., sr3=0.;
float cr1=0., cr2=0., cr3=0.;
int hertz=100, duration=10000;
float sx=0.,sy=0.;
float sxavg,syavg,sxstart,systart,sxseed,syseed;
/* float pi=3.141592; */
float a;
float angle,range,radius,xcenter,ycenter,xpt,ypt,xout,yout,xin,yin;
int   iloop, iloop2, iswapflag=1, ipoint,iface;
int iplate_a,iplate_b,iplate_c;
int zin,zout,c;
char string[80],string_value[4],str_pointer;
int istring_start,ivalue,ivert,ix,iy,iz;
float tempiplate, tempzdepth;
struct { int x,y ; } points[20];

int xlow,xhgh,ylow,yhgh,i,iii,jjj,istep,istepoff,ik,jk;

unsigned char *virtual_buffer;        /* Declare Virtual Buffer */

int t1=0,t2=0,p1=0;
char dummy,buffer[80];
FILE *fp;
void keyboard(void);
void keyboard_input(void);
void calc_3d(void);
void rotation(void);
void vic_sort(void);
void draw_triangle(int icolor);
float maximum(float x,float y);
float minimum(float x,float y);
main()
{
        fp=fopen("engine._3d","r");         /* open icon file */
/*	printf("Opened File \n");   */
        ipoint=0;
        iface=0;
	while(feof(fp) == 0) {              /* read until End-Of-File is reached */
/*	fread(&string,80,1,fp);  */         /* read line as string */
	fgets(string,80,fp);                /* read line from file as string */
/*	for(i=1;i<=80;i++) {
	printf("%c",string[i-1]); }  */

	istring_start=0;
	str_pointer=strstr(string,"Vertices:");
	if(str_pointer!=NULL) {
/*	printf("Vertices: found at position %i \n",str_pointer);
	for(i=1;i<=80;i++) {printf("%c",string[i-1]);}
	keyboard();                                      */
        sscanf(string,"%*s%d",&nvert);
/*	printf("The number of verticies assigned is %i \n",nvert); */
	str_pointer=NULL;
/*	keyboard();        */                         }

	str_pointer=strstr(string,"X:");
	if(str_pointer!=NULL) {
/*	printf("Found X: Y: Z: Data \n");
	for(i=1;i<=80;i++) {printf("%c",string[i-1]);}    */
/*	sscanf(string,"%*s%f, %*s%f, %*s%f\n",&x,&y,&z);  */
	sscanf(string,"              X: %f, Y: %f, Z: %f",&x,&y,&z);
        vertex[0][ipoint]=x;
        vertex[1][ipoint]=y;
        vertex[2][ipoint]=z;
        ipoint=ipoint+1;

        xmax=maximum(xmax,x);                  /* find x,y,z mins and maxs for scaling */
        xmin=minimum(xmin,x);
        ymax=maximum(ymax,y);
        ymin=minimum(ymin,y);
        zmax=maximum(zmax,z);
        zmin=minimum(zmin,z);

/*	for(j=1;j<=ivert;j++) {
	fscanf(fp,"%*s%d%*s%d%*s%d \n",&x,&y,&z);   */
/*	printf("Assigned X: %f Y: %f Z: %f \n",x,y,z); */
	str_pointer=NULL;
	/* keyboard(); */   }

	str_pointer=strstr(string,"Faces:");
	if(str_pointer!=NULL) {
/*	printf("Found Face Number \n");        */
        sscanf(string,"%*s%d",&nfaces);
/*	printf("The number of faces is %i \n",nfaces);   */
        str_pointer=NULL;
/*	keyboard();        */    }

        str_pointer=strstr(string,"A:");
	if(str_pointer!=NULL) {
/*	printf("Found Face Data \n");      */
	sscanf(string,"      A: %i, B: %i, C: %i,%i",&aa,&bb,&cc,&icolor);
        faces[0][iface]=aa;
        faces[1][iface]=bb;
	faces[2][iface]=cc;
	face_color[iface]=icolor;
        iface=iface+1;

/*	printf("Assigned Face A: %i B: %i C: %i D: %i \n",aa,bb,cc,icolor); */
	str_pointer=NULL;
	/* keyboard(); */           }
				  }               /* End-Of-File */
/*	printf("Finished Reading Object File");
	keyboard();                             */
        xspread=xmax - xmin;                      /* Find biggest spread in x,y,z */
        yspread=ymax - ymin;
        zspread=zmax - zmin;
        spread=maximum(xspread,yspread);
	spread=maximum(spread,zspread);
/*	printf("The spreads are: T%f  X%f  Y%f  Z%f \n",
		spread,xspread,yspread,zspread);
	keyboard();                                   */

        virtual_buffer=(unsigned char *)malloc(320*200); /* Allocate Memory for Virtual Buffer */
                                                         /* Virtual Buffer is Off Screen       */

        set_mode(0x13);                                  /* Establish VGA Mode 13h) */

	d=698.;                                          /* Adjust Perspective View Scale Factor */
        movez=1200;
	rd1=0; rd2=0; rd3=0;
				       /* set up initial orientation */
	rd1= 30;
        rd2=-40;
        rd3=-20;
	for(i=1; i!=0; i++ ) {

	rd1=rd1+1;                     /* increment roll pitch yaw angles */
	rd2=rd2-2;
	rd3=rd3-1;

	if(i==1280) goto end_label ;

	memset(virtual_buffer,0,64000);    /* Clear Virtual Page  - to zero */
	keyboard_input();

	r1=(pi/180.)*rd1;
	r2=(pi/180.)*rd2;
	r3=(pi/180.)*rd3;

	rotation();


        for(ipl=1; ipl<=nfaces; ipl++) {             /* read sequence of faces to be drawn */
        inumplate=ipl-1;                             /* step through each face           */
                                                     /* gather info for face to be drawn */
                                                     /* 0= A vertex for plate        */
                                                     /* 1= B vertex for plate        */
                                                     /* 2= C vertex for plate        */

	iplate_a =faces[0][inumplate];
        iplate_b =faces[1][inumplate];
	iplate_c =faces[2][inumplate];               /* set pen for this plate */
	icolor   =face_color[inumplate];             /* store color for this plate */
	if(icolor >=15) icolor=10;
	if(icolor <= 0) icolor=10;                   /* make sure pen is visible */

	sxavg=0.;
	syavg=0.;
	npplate=0;
	sxstart=0.;
	systart=0.;

	npoints=3;
	for(k=1; k<=npoints; k++) {                   /* visit every vertice which makes up plate to be drawn */
        npplate=npplate+1;                            /* count points which make up each plate                */
	inumvertice=faces[k-1][inumplate];            /* pick-up vertex numbers sequentially for this face */

        x=vertex[0][inumvertice];                     /* pick=up x,y,z for this vertice  */
	y=vertex[1][inumvertice];
	z=vertex[2][inumvertice];

	x=(x-cgx)*(300./spread);                  /* normalize and scale object coords */
	y=(y-cgy)*(300./spread);
	z=(z-cgz)*(300./spread);

/*	z=z + movez;        */
	if(x==0.) x=.00001;
	if(y==0.) y=.00001;
	if(z==0.) z=.00001;

	calc_3d();                                  /* transform x,y,z  into x,y screen coords */
	sxb=sx+125;                                 /* center object on screen */
	syb=sy+54;                                  /* center object on screen */
	if(syb<0)   syb=0;                          /* clip min y screen value */
	if(syb>199) syb=199;                        /* clip max y screen value */
	points[npplate-1].x=sxb;
        points[npplate-1].y=syb;
	if(k==1) {
	sxa=sxb;
	sya=syb;
	sxstart=sxa;
        systart=sya;};
/*        moveto(sxa,sya);       */
/*        lineto(sxb,syb);       */                   /* draw vector            */
        sxa=sxb;                                      /* save last point x      */
        sya=syb;                                      /* save last point y      */
			}                             /* use y avg to seed fill pt */

        points[npplate].x=sxstart;                    /* return to start point to ensure closed polygon */
	points[npplate].y=systart;                    /* return to start point to ensure closed polygon */
	npplate=4;                                    /* adjust # points by one to return to original start point for closed polygon */

        draw_triangle(icolor);      };                /* outline object with line drawing around polygons */
        memcpy(VGA,virtual_buffer,64000);             /* Page Swap Virtual Page to Video Memory = VGA */

        };                                            /* close plate loop   */
						      /* close rotation loop */
end_label: ;

	}                                             /* close main */

/*-------------------------------------------------------------
        SUBROUTINE: DRAW TRIANGLE
        Draw Triangle Outline Using Mode 13h (320 x 200)
	Draw_Fast_Line Bresenham Routine                      */

void draw_triangle(int icolor) {
int x1,y1,x2,y2,iloop;
for (iloop=0; iloop<=2; iloop++) {
    x1=points[iloop].x;
    y1=points[iloop].y;
    x2=points[iloop+1].x;
    y2=points[iloop+1].y;
    if(iloop==2) {x2=points[0].x; y2=points[0].y;}
    line2fast(x1,y1,x2,y2,icolor,virtual_buffer);}
    return;}

/*-------------------------------------------------------------
        SUBROUTINE: MAXIMUM
   Returns larger of two real numbers                          */

float maximum(float x, float y){
if(x >= y) {return x;};
if(x <= y) {return y;}; }

/*-------------------------------------------------------------
        SUBROUTINE: MINIMUM
   Returns smaller of two real numbers                         */

float minimum(float x, float y){
if(x <= y) {return x;};
if(x >= y) {return y;}; }
